Steps for creating a new release of this module

--------------------------------------------------------------------------------

1. Apply short array syntax
2. Inspect code
3. Run tests
4. Generate and edit release notes
5. Tag a release
6. Update project page
7. Create new release

--------------------------------------------------------------------------------

# Apply to short array syntax

    wget https://raw.githubusercontent.com/thomasbachem/php-short-array-syntax-converter/master/convert.php
    find . -name "*.install" -exec php "convert.php" -w "{}" \;
    find . -name "*.module" -exec php "convert.php" -w "{}" \;
    find . -name "*.php" -exec php "convert.php" -w "{}" \;
    find . -name "*.inc" -exec php "convert.php" -w "{}" \;
    rm convert.php

--------------------------------------------------------------------------------

# Inspect code

**References**

- [Installing Coder Sniffer](https://www.drupal.org/node/1419988)

**PHPStorm**

- [Drupal Development using PhpStorm](https://confluence.jetbrains.com/display/PhpStorm/Drupal+Development+using+PhpStorm#DrupalDevelopmentusingPhpStorm-CoderandPHPCodeSnifferIntegration)

**Online**

- [pareview.sh](http://pareview.sh)  
   http://git.drupal.org/project/toc_api.git 8.x-1.x

**[Commandline](https://www.drupal.org/node/1587138)**

    # Check Drupal coding standards
    phpcs --standard=Drupal --extensions=php,module,inc,install,test,profile,theme,js,css,info,txt,md modules/sandbox/toc_api

    # Check Drupal best practices
    phpcs --standard=DrupalPractice --extensions=php,module,inc,install,test,profile,theme,js,css,info,txt,md modules/sandbox/toc_api

--------------------------------------------------------------------------------
    
# Run tests

**SimpleTest**

GUI (admin/config/development/testing)

Command-line (from site root)

    # Run all test included this module 
    php core/scripts/run-tests.sh --url http://localhost/d8_dev --module toc_api
    
**PHPUnit tests**

PHPUnit tests needs to be run individual if this module is placed in a 
modules sub-directory (ie module/contrib or modules/sandbox).
 
- [/core/phpunit.xml.dist only finds top-level contrib modules](https://www.drupal.org/node/2499239)

If the above patch is applied or this module is in the main /modules directory. 

This command will execute all PHPUnit tests for this module

    cd core
    php ../vendor/phpunit/phpunit/phpunit --group TocApi

The below commands can be used to execute each individual PHPUnit test.

    cd core
    php ../vendor/phpunit/phpunit/phpunit ../modules/sandbox/toc_api/tests/src/Unit/TocFormatterTest.php
    php ../vendor/phpunit/phpunit/phpunit ../modules/sandbox/toc_api/tests/src/Unit/TocTest.php   
    
    
--------------------------------------------------------------------------------

# Generate and edit release notes

Git Release Notes for Drush (https://www.drupal.org/project/grn)

    drush release-notes 8.x-1.0-N 8.x-1.x
    
--------------------------------------------------------------------------------
    
# Tag a release

    git tag 8.x-1.0-N
    git push --tags
    git push origin tag 8.x-1.0-N

--------------------------------------------------------------------------------

# Update project page

Steps for converting README.md to valid and supported HTML for this module's 
Drupal.org project page.

- [Convert Markdown to HTML](http://daringfireball.net/projects/markdown/dingus)
- [Tidy HTML](https://infohound.net/tidy/)
    - No indent
    - No wrap   
- Manually cleanup
    - Remove `<html>` tags.
    - Remove 'Contents of this file'.
    - Update example code and wrap in `<pre>` tag.
- Update project page](https://www.drupal.org/node/2685977/edit)
    - Preview 
    - Save

--------------------------------------------------------------------------------

# Create new release

- [Create Release](https://www.drupal.org/node/add/project-release/2685977)
- [Administer releases](https://www.drupal.org/node/2685977/edit/releases)
